;;;--------------------------------------------------------------------;;;
;;;                 " "                  ;;;
;;;                    BsSurf.lsp Version 2.0                          ;;;
;;;               AutoCAD 2000 (15) for Windows                     ;;;
;;;                          16.02.00                                  ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;

;;
;;         :
;;         " "
;;                BsSurf
;;

;=============================================================
;;;     
(setq BsSurf 1)

;=============================================================
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;   rNum  
;n   
(defun Round ( rNum n / nrNum inrNum idnrNum rndNum)
    ;rNum -   (3.124446)
    ;n -     (2)
    ;nrNum - rNum,   10   n
    ;inrNum -   nrNum
    ;idnrNum -   nrNum,   10
    ;rndNum -  

     (setq nrNum (* rNum (expt 10 n)))     ;(312.446)
     (setq inrNum (atof (rtos nrNum 2 0))) ;(312.0)
     (setq nrNum (- nrNum inrNum))         ;(0.446)
     (setq rndNum nil)                     
     (while (null rndNum)
          (setq nrNum (* nrNum 10.0))                  ;(1- 4.46, 2- 4.6, 3- 6.0)
          (setq idnrNum (atof (rtos nrNum 2 0)))       ;(1- 4.0,  2- 4.0, 3- 6.0)
          (cond
               ((= idnrNum 4) (setq nrNum (- nrNum idnrNum)))                   ;(1- 0.46, 2- 0.6)
               ((< idnrNum 4) (setq rndNum (/ inrNum (expt 10.0 n))))           ;
               ((> idnrNum 4) (setq rndNum (/ (+ inrNum 1.0) (expt 10.0 n))))   ;(3- 3.13)
          )
     )
     t rndNum    ;  (3.13)
)

;  
(defun SetOpt ()
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

;  
(defun RetOpt ()
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;    
(defun arcsin ( x / )
    (atan 
        (/  x  (sqrt (- 1.0 (* x x))) )
    )
) ; defun arsin

;-------------------------------------------------------------
;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;  SelObj
(defun MoveObj (SelObj BasePt)
	(command "_Move" SelObj "" bp pause)
	(setq BasePt (getvar "Lastpoint"))
	(princ (strcat "\n : " BasePt))
	T BasePt
)

;  SelObj
(defun RotateObj (SelObj BasePt)
	(princ "\n : ")
	(command "_Rotate" SelObj "" BasePt pause)
)

(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $RetLProp ()
;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	(setvar "CELWEIGHT" oldWeight)
)

(defun $setLTypeDim ()
	(if (= (getvar "TILEMODE") 0)   
		(setq Scale 1)                   ;   
		(setq Scale (getvar "dimscale")) ; 
		                                 ;    
	)
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(setvar "CELWEIGHT" ArWD)
)

;  
(defun ins_Txt (t_pt t_ang t_just t_h txt / t_l t_list th CurTxtStyle)
	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))

    (if (> th 0)
        (if (not (null t_just))
            (command "_text" "_J" t_just t_pt (rtd t_ang) txt)
            (command "_text" t_pt (rtd t_ang) txt)
        )
        (if (not (null t_just))
            (command "_text" "_J" t_just t_pt t_h (rtd t_ang) txt)
            (command "_text" t_pt t_h (rtd t_ang) txt)
        )
    )
    (setq t_list (list (cons '1 txt) (cons '40 t_h)))
    (setq t_l (car (cadr (textbox t_list))))
    t t_l
)


;;;   
;=============================================================

;;; 
;=============================================================
;      ,
;     
(defun drw_BsSurf3ang ( pt ang / pt1 pt2 pt3 SS_d Scale)
	(if (= (getvar "TILEMODE") 0)   
		(setq Scale 1)                   ;   
		(setq Scale (getvar "dimscale")) ; 
		                                 ;    
	)

    (setq pt1 (polar pt ang (* 3 Scale)))
    (setq pt2 (polar pt1 (- ang (dtr 180)) (* 6 Scale)))
    (setq pt3 (polar pt1 (- ang (dtr 120)) (* 6 Scale)))

    (setq SS_d (ssadd))
    (osnap_off)
    ($SaveLProp)
    ($setLTypeDim)
    (command "_line" pt1 pt2 "")
    (ssadd (entlast) SS_d)
    (command "_line" pt2 pt3 "")
    (ssadd (entlast) SS_d)
    (command "_line" pt3 pt1 "")
    (ssadd (entlast) SS_d)
    (osnap_on)
    ($RetLProp)
    t SS_d
)

;    
;   
(defun get_pt_t ( pt pt1 pt2 bl / flag bp bp1)
	(setq flag nil)
	;(setq bp (grread T (+ 1 4) 0))	;   
	;(if (= 5 (car bp))		        ;      
							        ;    
		(progn
	;		(setq bp1 (car (cdr bp)))
			(setq bp1 (get_np pt1 pt2 pt (polar pt (+ ang (dtr 90)) 10)))
    	    (if (and
	                (= (round (sin (+ (angle pt1 pt2) (dtr 90))) 4) (round (sin (angle pt bp1)) 4))
	                (= (round (cos (+ (angle pt1 pt2) (dtr 90))) 4) (round (cos (angle pt bp1)) 4))
	                (> (distance pt bp1) bl)
	            )
			    (drw_vect pt bp1)
			)
		)
	;)
	(princ "\n    : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	            ;      
							            ;    
			(progn
			    (setq bp1 (car (cdr bp)))
			    (setq bp1 (get_np pt1 pt2 pt bp1))
			    (if (and
			            (= (round (sin (+ (angle pt1 pt2) (dtr 90))) 4) (round (sin (angle pt bp1)) 4))
			            (= (round (cos (+ (angle pt1 pt2) (dtr 90))) 4) (round (cos (angle pt bp1)) 4))
			            (> (distance pt bp1) (+ TxtH (* 5 Scale)))
			        )
			        (drw_vect pt bp1)
			    )
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
		    (if (and
		            (= (round (sin (+ (angle pt1 pt2) (dtr 90))) 4) (round (sin (angle pt bp1)) 4))
		            (= (round (cos (+ (angle pt1 pt2) (dtr 90))) 4) (round (cos (angle pt bp1)) 4))
		            (> (distance pt bp1) (+ TxtH (* 5 Scale)))
		        )

		        (setq flag T)
		    )
		)
	)
	(command "'_redrawall")
    t bp1
)

;      sp   ep
(defun drw_vect (sp ep)
    (command "'_redrawall")
    (grdraw sp ep 1)
)

;    np,   
;    pt  p1 p2,  
; l,     up   p1 p2
(defun get_np (p1 p2 pt up / l ang np ang_u)
    (setq ang (angle p1 p2))
    (setq ang_u (angle pt up))
    (setq l (distance pt up))
    (setq l (* l (sin (- ang_u ang))))
    (setq np (polar pt (+ ang (dtr 90)) l))
    
    t np
)

;;;  
;=============================================================



;;;  
;=============================================================

;    " "
(defun C:BsSurf ( / pt SS_d SS ent_d list_d ang pt1 pt2 pt3 pt4 pt5 Scale pt_t Bs_Dis ins_ang)
	(if (= (getvar "TILEMODE") 0)   
		(setq Scale 1)                   ;   
		(setq Scale (getvar "dimscale")) ; 
		                                 ;    
	)
    (initget 1)
    (setq pt (getpoint "\n     : "))
    (setq SS_d (drw_BsSurf3ang pt 0))
    (command "_rotate" SS_d "" pt Pause)
    (setq ent_d (ssname SS_d 0))
    (setq list_d (entget ent_d))
    (setq pt1 (cdr (assoc 10 list_d)))
    (setq pt2 (cdr (assoc 11 list_d)))
    (setq ang (angle pt1 pt2))
    
    (setq pt_t nil)
    (setq pt_t (get_pt_t pt pt1 pt2 (+ TxtH (* 5 Scale))))
    (command "_erase" SS_d "")
    (if (not (null pt_t))
        (progn
            (setq pt1 (polar pt ang (* 3 Scale)))
            (setq pt2 (polar pt1 (- ang (dtr 180)) (* 6 Scale)))
            (setq pt3 (polar pt1 (+ ang (dtr 120)) (* 6 Scale)))
            (osnap_off)
            ($SaveLProp)
            ($setLTypeDim)
            (setq SS (ssadd))
            (command "_solid" pt1 pt2 pt3 pt3 "")
            (ssadd (entlast) SS)
            (command "_line" pt pt_t "")
            (ssadd (entlast) SS)
            (setq pt1 (polar pt_t ang TxtH))
            (setq pt2 (polar pt_t (- ang (dtr 180)) TxtH))
            (setq pt3 (polar pt1 (+ ang (dtr 90)) (* TxtH 2)))
            (setq pt4 (polar pt2 (+ ang (dtr 90)) (* TxtH 2)))
            (command "_pline" pt1 pt2 pt4 pt3 "_c")
            (ssadd (entlast) SS)
            (setq pt1 (polar pt_t (+ ang (dtr 90)) TxtH))
            (setq Bs_Dis nil)
            (setq Bs_Dis (getstring "\n   <A>: "))
            (if (or (null Bs_Dis) (= Bs_Dis "")) (setq Bs_Dis ""))
            (if (or 
                   (> (round (cos ang) 4) 0.0) 
                   (= (round ang 4) (round (dtr 90.0) 4))
                )
                (setq ins_ang ang)
                (setq ins_ang (- ang (dtr 180)))
            )
            (ins_Txt pt1 ins_ang "_MC" (* TxtH 1.3) Bs_Dis)
            
            ;     
            ;      
            ;  ,   ";" 
            ;   
            (ssadd (entlast) SS)
            
            
            ($RetLProp)
            (osnap_on)
            (UnBlock pt SS)
        )
    )
    (terpri)
    ;(prin1)
    (princ)
)


;=============================================================
(princ "\n     BsSurf.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
